/*
 * $Id$
 * Author: Karoly Bosa
 *
 * (C) 2008 by Research Institute for Symbolic Computation, Linz, Austria
 * All rights reserved. See COPYRIGHT in top-level directory.
 */

#ifndef TAAGIMPL_H_
#define TAAGIMPL_H_

/* taag.h includes most of the definitions (all of the user-visible ones) */
#include <taag.h>

/* The rest of these contain the details of the structures that are not
   user-visible */
#include <stdlib.h>
#include <string.h>

#define _TAAG_GET_NR_OF_PROCESSES(op) (int *)_taag_getPointer1(NR_PROCS, op)
#define _TAAG_GET_LIST_OF_PROCESSES(op) (int **)_taag_getPointer1(LIST_PROCS, op)
#define _TAAG_GET_DISTANCES(op) (int *)_taag_getPointer1(DISTANCES, op)

#define _TAAG_GET_LATENCIES(op) (double *)_taag_getPointer2(LATENCIES, op)
#define _TAAG_GET_HOSTNAMES(op) (char **)_taag_getPointer2(HOSTNAMES, op)
#define _TAAG_GET_NR_CPUS(op) (int *)_taag_getPointer2(CPUS, op)
#define _TAAG_GET_NR_PROCS_ON_HOST(op) (int *)_taag_getPointer2(NR_PROCS_ON_HOSTS, op)
#define _TAAG_GET_LIST_OF_PROCS_ON_HOSTS(op) (int **)_taag_getPointer2(PROCS_ON_HOSTS, op)

#define _TAAG_GET_HOSTS(op) (int *)_taag_getPointer3(HOSTS_ON_LANS, op)

//enum _pointer_types{NR_PROCS, LIST_PROCS, NR_EDGES, LIST_EDGES, DISTANCES};
enum _pointer_types{NR_PROCS, LIST_PROCS, DISTANCES,
					LATENCIES, HOSTNAMES, CPUS, HOSTS_ON_LANS, NR_PROCS_ON_HOSTS,  PROCS_ON_HOSTS};

extern int _taag_initialized;
extern int _hw_initialized;

enum _schema_types _taag_getType();
int _taag_getNumberOfGroups();
int _taag_getDepth();

int _taag_nrOfLAN();
int _taag_nrOfHost();
int _taag_nrOfCPUs();
int _taag_getHost(int);
int _taag_getLAN(int);

void *_taag_getPointer1(enum _pointer_types, int);
void *_taag_getPointer2(enum _pointer_types, int);
void *_taag_getPointer3(enum _pointer_types, int);



#endif /* TAAGIMPL_H_ */
