/*
 * $Id$
 * Author: Karoly Bosa
 *
 * (C) 2008 by Research Institute for Symbolic Computation, Linz, Austria
 * All rights reserved. See COPYRIGHT in top-level directory.
 */

#ifndef XML_PARSER_H_
#define XML_PARSER_H_

int _taag_xml_openFile(char *);
int _taag_xml_fileOpened(int *);
int _taag_xml_validate();
int _taag_xml_free();
int _taag_xml_getExecutable(char *);
int _taag_xml_getAppId(char *);
int _taag_xml_getTimeStamp(char *);
int _taag_xml_getSchemaType(char *);
int _taag_xml_getNumberOfGroups(unsigned int *);
int _taag_xml_getGroupSizes(unsigned int, unsigned int *);
int _taag_xml_getGroupMembers(unsigned int, unsigned int *, unsigned int **);
int _taag_xml_getEdgeMatrix(unsigned int, int *);

int _taag_xml_isTopologyGiven(int *);
int _taag_xml_getNumberOfLANs(unsigned int *);
int _taag_xml_getHosts(unsigned int, int *);
int _taag_xml_getHostnames(int, char **);
int _taag_xml_getNumberOfCPUs(int, int *);
int _taag_xml_getDirectories(int nrHost, char **);
int _taag_xml_getLatency(int, double *);

int _taag_xml_getNumberOfProcsOnHosts(int, int *);
int _taag_xml_getProcsOnHosts(int, int *, int **);
#endif /* XML_PARSER_H_ */
